using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Frief
{

    public class BDSMSaddles : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "Firef";
        public string pluginName = "BDSM-Sattle";
        public string pluginVersion = "1";
        public string pluginDate = "09/08" + "/2021";
        public string pluginDescription = @"Used";
        #endregion

        #region Vars    



        public GameObject player;
        public GameObject Ancor;

        protected JSONStorableFloat ScrubA;

        private float previousValue1;

        private float maxY;
        private float minY;



        private string objectNameSearchString = "AnchorPoint";
        public Transform ObjectRoot;
        public Transform BSDMSaddle;
        public Transform Ancorpoint;


        private Renderer BSDMSaddleRenderer;


        private bool editorInitialized = false;
        private int initLoops = 0;
        private int maxInitLoops = 360; //3600 for one minute

        private static Atom currentAtom;
        private static string currentAtomName = "None";
        private static string tempAtomName = "None";

        #endregion

        public override void Init()
        {
            try
            {
                if (containingAtom.type != "CustomUnityAsset")
                {
                    SuperController.LogError("BDSM-Saddle: This CUA could not be initialized properly.Please select a compatible object and reload the script.");
                    return;
                }


                //**************  ScrubA
                maxY = 0.0745f;
                minY = -0.0491f;
                ScrubA = new JSONStorableFloat("Ancorpointnt Hight", 0, -0.05f, 0.05f, true);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);


                // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("Help",
                    "<color=#000><size=35><b>Help</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Simple script to allow you to set the hight for for the Ancorpoints .\n\n" +
                    "Youn can find it under https://hub.virtamate.com/members/frief.1649 \n\n" +
                    "</color>");
                UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 1100.0f;

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
            
        }

              // Update is called with each rendered frame by Unity
        void Update()
        {
            var Slider1 = ScrubA.val;

            if (initLoops < maxInitLoops && editorInitialized == false)
            {
                initLoops++;
                InitEditor();
            }
            if (initLoops == maxInitLoops)
            {
                //SuperController.LogError("BDSMSaddle : This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                initLoops++; // To avoid spamming the log with the error
            }


                if (previousValue1 != Slider1)
                {
                    OnSliderChanged();
                }

        }

        private bool InitEditor()
        {
            if (editorInitialized == true) return true;

            ObjectRoot = getObjectRoot(containingAtom.reParentObject);
            if (ObjectRoot == null)
            {
                return false;
            }

            BSDMSaddle = ObjectRoot.Find("fixation");


            // I found my transforms, now the rest
            if (BSDMSaddle)
            {
                BSDMSaddleRenderer = BSDMSaddle.GetComponent<Renderer>();
               

                if (BSDMSaddleRenderer)
                {
                    editorInitialized = true;
                    return true;
                }
                else
                {
                   // SuperController.LogError("BDSMSaddle : error your CUA has a transform with the good name but does not have a renderer.");
                    initLoops = maxInitLoops;
                    return false;
                }
            }
            else
            {
               // SuperController.LogError("BDSMSaddle : your CUA is missing mandatory components ( transform name cube and sphere ).");
                initLoops = maxInitLoops; // We don't have what we need, we consider the initialization failed
                return false;
            }

            return false;
        }

        private Transform getObjectRoot(Transform parent)
        {
            foreach (Transform child in parent)
            {
                if (child.name.Contains(objectNameSearchString))
                {
                    return child;
                }
                else
                {
                    Transform childSearch = getObjectRoot(child);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }





        void OnSliderChanged()
        {

            

            var SattleX = BSDMSaddle.transform.localPosition.x;
            var SattlePosY = BSDMSaddle.transform.position.y;
            var SattleZ = BSDMSaddle.transform.localPosition.z;
            var Slider1 = ScrubA.val;
            var a = Slider1;
        

            if (BSDMSaddle.transform.position.y < minY)
             {
                 BSDMSaddle.localPosition = new Vector3(SattleX, minY, SattleZ);
                 previousValue1 = Slider1;
             }


             if (BSDMSaddle.transform.position.y > maxY)

             {
                 BSDMSaddle.localPosition = new Vector3(SattleX, maxY, SattleZ);
                 previousValue1 = Slider1;
             }

            BSDMSaddle.transform.localPosition = new Vector3(BSDMSaddle.transform.localPosition.x, Slider1, BSDMSaddle.transform.localPosition.z);

            previousValue1 = Slider1;


        }

        
    }
}